## Validate AWS role access

### cURL

```bash
curl --request POST \
  --url https://app.barndoor.ai/api/llm-gateway/admin/connections/aws-role-validate \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "region": "us-east-1",
  "iam_role_arn": "arn:aws:iam::222222222222:role/customer-bedrock",
  "external_id": "bd-ext-9f3c1"
}
'```

### Python

```python
import requests

url = "https://app.barndoor.ai/api/llm-gateway/admin/connections/aws-role-validate"

payload = {
    "region": "us-east-1",
    "iam_role_arn": "arn:aws:iam::222222222222:role/customer-bedrock",
    "external_id": "bd-ext-9f3c1"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript

```javascript
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    region: 'us-east-1',
    iam_role_arn: 'arn:aws:iam::222222222222:role/customer-bedrock',
    external_id: 'bd-ext-9f3c1'
  })
};

fetch('https://app.barndoor.ai/api/llm-gateway/admin/connections/aws-role-validate', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```php
<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://app.barndoor.ai/api/llm-gateway/admin/connections/aws-role-validate",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'region' => 'us-east-1',
    'iam_role_arn' => 'arn:aws:iam::222222222222:role/customer-bedrock',
    'external_id' => 'bd-ext-9f3c1'
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
```

### Go

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://app.barndoor.ai/api/llm-gateway/admin/connections/aws-role-validate"

payload := strings.NewReader("{\n  \"region\": \"us-east-1\",\n  \"iam_role_arn\": \"arn:aws:iam::222222222222:role/customer-bedrock\",\n  \"external_id\": \"bd-ext-9f3c1\"\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))

}
```

### Java

```java
HttpResponse<String> response = Unirest.post("https://app.barndoor.ai/api/llm-gateway/admin/connections/aws-role-validate")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"region\": \"us-east-1\",\n  \"iam_role_arn\": \"arn:aws:iam::222222222222:role/customer-bedrock\",\n  \"external_id\": \"bd-ext-9f3c1\"\n}")
  .asString();
```

### Ruby

```ruby
require 'uri'
require 'net/http'

url = URI("https://app.barndoor.ai/api/llm-gateway/admin/connections/aws-role-validate")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"region\": \"us-east-1\",\n  \"iam_role_arn\": \"arn:aws:iam::222222222222:role/customer-bedrock\",\n  \"external_id\": \"bd-ext-9f3c1\"\n}"

response = http.request(request)
puts response.read_body
```

### Responses

#### 200

```json
{
  "ok": true
}
```

#### 400

```json
{
  "error": "BadRequest",
  "message": "request_timeout_secs must be between 1 and 3600"
}
```

### Authorizations

- **Authorization**: `string` (required) - JWT obtained through Barndoor's authentication flow. Pass the token verbatim in `Authorization: Bearer <token>`. Use the Barndoor SDK's `loginInteractive()` helper to obtain a token in scripts and notebooks.

### Body
- **region**: `string` (required) - Example: "us-east-1"
- **iam_role_arn**: `string` (required) - Example: "arn:aws:iam::222222222222:role/customer-bedrock"
- **external_id**: `string` (required) - Example: "bd-ext-9f3c1"
